var express = require('express');
var path 	= require('path');
var favicon = require('serve-favicon');
var logger 	= require('morgan');
var cookieParser = require('cookie-parser');
var bodyParser = require('body-parser');
var http 	= require('http');
var multer	= require('multer');

var ko2ib = require('./routes/ko2ib');

var app = express();

// view engine setup
app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'ejs');

// uncomment after placing your favicon in /public
//app.use(favicon(path.join(__dirname, 'public', 'favicon.ico')));
app.use(logger('dev'));
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({ extended: false }));
app.use(cookieParser());
app.use(express.static(path.join(__dirname, 'public')));

//app.use('/', routes);
//app.use('/users', users);

// ------ adding
var uploader = multer({dest: "./uploads/"}).single("files");

// server
app.set('port', process.env.PORT || 3000);
var server = http.createServer(app);
server.listen(app.get('port'), function(){
	console.log("Express server listening on port " + app.get('port'));
});

// socket.io and initialize ko2ib
var basicAuth = require('basic-auth-connect');
app.all('/', basicAuth(function(user, password) {
	// return user == 'x' && password == 'y';
	var auth = {
		users: {
			ko2ib: 'ko2ib'
		}
	};
	return auth.users[user] && auth.users[user] == password;
}));
var io = require("socket.io").listen(server);
ko2ib.main(app, io, uploader);
// -----

// catch 404 and forward to error handler
app.use(function(req, res, next) {
	var err = new Error('Not Found');
	err.status = 404;
	next(err);
});

// error handlers

// development error handler
// will print stacktrace
if (app.get('env') === 'development') {
	app.use(function(err, req, res, next) {
		res.status(err.status || 500);
		res.render('error', {
			message: err.message,
			error: err
		});
	});
}

// production error handler
// no stacktraces leaked to user
app.use(function(err, req, res, next) {
	res.status(err.status || 500);
	res.render('error', {
		message: err.message,
		error: {}
	});
});

//module.exports = app;
